# Carnegie Mellon University
# Copyright (c) 2009
# All Rights Reserved.
#
# Any use of this software must follow the terms
# outlined in the included LICENSE file.
#

#This computes the average over hypotheses of the ratio of hypothesis length to average corresponding reference length.

def count_words(str)
  str.split(/\s+/u).size
end

class Length
  def summary_score(request)
    @ratios = []
    sum = 0.0
    ref_count = request.ref.number.to_f
    request.hyp.lines.each_index do |i|
      hyp_length = count_words(request.hyp.lines[i])
      ref_sum = 0
      request.ref.range(i).each do |r|
        ref_sum += count_words(request.ref.laced_lines[r])
      end
      ratio = hyp_length.to_f / (ref_sum.to_f / ref_count)
      @ratios << ratio if request.individual
      sum += ratio
    end
    [sum / request.hyp.lines.size.to_f]
  end
  def summary_format(request)
    ["%0.02f"]
  end
  def individual_score(request)
    [@ratios]
  end
  def individual_format(request)
    ["%0.02f"]
  end
end
