require SCORE_DIR + '/lib/shell_escape'

#Make annoying parentheses after each sentence
def terrify(lines, group_size, output_file_name)
  output_file = File.new(output_file_name, "w")
  #1-index
  index = group_size
  lines.each do |l|
    output_file.write l.strip
    output_file.puts " (" + (index / group_size).to_s + ")"
    index += 1
  end
  output_file.close
end

class TER
  def summary_score(request)
    hyp_ter = request.output.temp("test.terin")
    terrify(request.hyp.lines, 1, hyp_ter)
    ref_ter = request.output.temp("ref.terin")
    terrify(request.ref.laced_lines, request.ref.number, ref_ter)
    output_file = request.output.perm("ter_out")
    request.output.record_perm(output_file + ".sum")
    args = ["java", "-jar", SCORE_DIR + "/tercom-0.7.25/tercom.7.25.jar", "-r", ref_ter, "-h", hyp_ter]
    args << "-N" unless request.no_norm
    args += ["-o", "sum", "-n", output_file]
    args << "-s" if request.cased or request.no_norm
    system_with_redirect(args, nil, output_file)
    score_line = File.new(output_file).readlines[-4]
    throw "Bad TER output in #{output_file}" unless score_line
    matched = score_line.match(/^Total TER: ([0-9]*.[0-9]*) \([0-9]*.[0-9]*\/[0-9]*.[0-9]*\)$/)
    throw "TER score line \"#{score_line}\" in #{output_file} did not parse" unless matched
    [matched[1].to_f * 100.0]
  end 
  def summary_format(request)
    ["%5.2f"]
  end
  def individual_score(request)
    summary_name = request.output.name("ter_out.sum")
    summary = File.new(summary_name)
    ["Hypothesis File:", "Reference File:", "Ave-Reference File:", "Sent Id", "------"].each do |h|
      l = summary.gets
      throw "Line '#{l}' in #{summary_name} does not begin with #{h}" if l[0..h.size - 1] != h
    end
    scores = []
    request.hyp.lines.size.times do |i|
      line = summary.gets
      throw "Ran out of segment score lines in #{summary_name}" unless line
      matched = line.match /\| *([0-9]*\.[0-9]*)$/
      throw "Bad segment line #{line} in #{summary_name} for segment #{i}" unless matched
      scores << matched[1].to_f
    end
    [scores]
  end
  def individual_format(request)
    summary_format(request)
  end
end
